# Author: Osborne

# NVRAM Variable Used
# get_fw_state	= 0: Initial State
#		  1: Failed to retrive the firmware image
#		  2: Retrived the firmware successfully

# Variable List
fw_server_specified=`nvram get fw_server_specified`
fw_location=`nvram get fw_location`

# Main Operation
echo get_fw.sh is running..
nvram set get_fw_state=0
cd /tmp

if [ "$1" = "debug" ]
then
	echo
	echo Command:
	echo wget ftp://${fw_server_specified}${fw_location}
	echo
fi

wget ftp://${fw_server_specified}${fw_location}

if [ "$?" = "0" ]
then
	echo Firmware Received from Server Successfully!
	nvram set get_fw_state=2
	echo get_fw.sh is done.
	exit 0
else
	echo Failed to Receive Firmware from Server!
	nvram set get_fw_state=1
	echo get_fw.sh is done.
	exit 1
fi

