/*******************************************************************************
Copyright (C) Marvell International Ltd. and its affiliates

********************************************************************************
Marvell GPL License Option

If you received this File from Marvell, you may opt to use, redistribute and/or 
modify this File in accordance with the terms and conditions of the General 
Public License Version 2, June 1991 (the "GPL License"), a copy of which is 
available along with the File in the license.txt file or by writing to the Free 
Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 or 
on the worldwide web at http://www.gnu.org/licenses/gpl.txt. 

THE FILE IS DISTRIBUTED AS-IS, WITHOUT WARRANTY OF ANY KIND, AND THE IMPLIED 
WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE ARE EXPRESSLY 
DISCLAIMED.  The GPL License provides additional details about this warranty 
disclaimer.

*******************************************************************************/

#define MV_ASMLANGUAGE
#include "mvOsAsm.h"
#define UART
#undef DDRII
#define DDRI
#undef ODT_CS0

#define MV_DV_REG_WRITE_ASM(fromReg, tmpReg, regOffs)  	\
        HTOLL(fromReg,tmpReg)                        ;	\
        ldr     tmpReg, =(CFG_DFL_MV_REGS + regOffs) ;	\
        str     fromReg, [tmpReg]                         

#define MV_DV_REG_READ_ASM(toReg, tmpReg, regOffs)                 \
                ldr     tmpReg, =(CFG_DFL_MV_REGS + regOffs) ;  \
        ldr     toReg, [tmpReg]                      ;  \
        HTOLL(toReg,tmpReg)


.section	".reset_vector_sect",#alloc, #execinstr

#if defined(MV_88F1181)

	/* set gpp out en */
        ldr r2, = 0xf33
        MV_DV_REG_WRITE_ASM(r1, r1, 0x10104)

	/* turn on debug led to 2 */
	ldr r2, = 0x8
        MV_DV_REG_WRITE_ASM(r1, r1, 0x10100)
         
         ldr pc, = 0xfff90000
                  

#elif defined(MV_88F5181)

        /* Read Device ID     */
        MV_DV_REG_READ_ASM (r6, r1, 0x40000)
        ldr   r1, = 0xffff0000
        and   r6, r6, r1
	ldr   r1, =0x52810000
        cmp   r6, r1
	bne   device_5181
	
device_5281:

	MV_DV_REG_READ_ASM (r6, r1, 0x40008)
	ldr   r1, = 0xff
	and   r6, r6, r1
	cmp   r6, #0x1  /* Orion 2 B0 */
        bne   device_5281_A0


device_5281_B0:
        MV_DV_REG_READ_ASM (r6, r1, 0x20120)

        ldr    r1, =0xFFFF8080
        and    r6, r6, r1
        ldr    r1, =0x821b
        orr     r6, r6, r1

        MV_DV_REG_WRITE_ASM (r6, r1, 0x20120)

	b device_cont
device_5281_A0:	
	b device_cont
device_5181:
	b device_cont
device_cont:

#if defined(RD_88F5182) && defined(MV_TINY_IMAGE)

        ldr pc, = 0xfffC0000
        
#elif defined(MV_VOIP) && defined(MV_TINY_IMAGE)

        /* jump to 0xfffC0000 */
        ldr pc, = 0xfffC0000        
        
#else

	/* jump to 0xfff90000 */	
        ldr pc, = 0xfff90000
        
#endif        

#endif         


.section	".dummy",#alloc, #execinstr
	.long 0xffffffff
	.long 0xffffffff
	.long 0xffffffff
	.long 0xffffffff



